<?php

namespace BS\RealTimeChat\ChatCommand;

class ClearUser extends AbstractCommand
{
    protected $user;

    public function canUse()
    {
        $message = $this->message;

        preg_match('/^\/clear\s\[user=([0-9]*)].*\[\/user]$/iu', $message->message, $matches);

        $user = $this->em()->find('XF:User', (int)$matches[1]);

        if (!$user)
        {
            return false;
        }

        $this->user = $user;

        return \XF::visitor()->canChatClear();
    }

    protected function _render()
    {
        $user = $this->user;

        $this->db()->delete('xf_bs_chat', 'user_id = ?', [
            'user_id' => $user->user_id
        ]);

        $this->app['chatEmitter']->emit('delete message', [
            'user_id' => $user->user_id
        ]);

        return false;
    } 
}