<?php

namespace BS\RealTimeChat\ChatCommand;

class Pm extends AbstractCommand
{
    protected $user;

    public function canUse()
    {
        $message = $this->message;

        preg_match('/^\/pm\s\[user=([0-9]*)].*\[\/user]/iu', $message->message, $matches);

        $user = $this->em()->find('XF:User', (int)$matches[1]);

        if (!$user)
        {
            return false;
        }

        $this->user = $user;

        return true;
    }

    protected function _render()
    {
        $message = $this->message;
        $user = $this->user;

        $message->bulkSet([
            'pm_user_id' => $user->user_id,
            'message' => preg_replace('/^\/pm\s,{0,1}\s{0,1}/iu', '', $message->message)
        ]);

        return true;
    } 
}