<?php

namespace BS\RealTimeChat\Finder;

use XF\Mvc\Entity\Finder;

class LongPollingEvent extends Finder
{
    public function hasOrEmptyRooms(array $roomIds = [])
    {
        $columnSqlName = $this->columnSqlName('room_ids');

        $parts = [
            $columnSqlName . ' = \'\''
        ];

        if (! empty($roomIds))
        {
            foreach ($roomIds as $roomId)
            {
                $parts[] = 'FIND_IN_SET(' . $this->quote($roomId) . ', '. $columnSqlName . ')';
            }
        }

        $this->whereSql(implode(' OR ', $parts));

        return $this;
    }

    public function afterTime($time)
    {
        $this->where('event_time', '>', $time);

        return $this;
    }

    public function inTypes(array $types)
    {
        $this->where('event_type', '=', $types);

        return $this;
    }
}