<?php

namespace BS\RealTimeChat\Notifier\Message;

use XF\Notifier\AbstractNotifier;

class Mention extends AbstractNotifier
{
    protected $message;

    public function __construct(\XF\App $app, \BS\RealTimeChat\Entity\Message $message)
    {
        parent::__construct($app);

        $this->message = $message;
    }

    public function canNotify(\XF\Entity\User $user)
    {
        return !($user->user_id == $this->message->user_id || $this->message->pm_user_id);
    }

    public function sendAlert(\XF\Entity\User $user)
    {
        $message = $this->message;
        return $this->basicAlert($user, $message->user_id, $message->User->username, 'chat_message', $message->message_id, 'mention');
    }
}