<?php

namespace BS\RealTimeChat\Pub\View;

use BS\RealTimeChat\Listener;
use XF\Mvc\View;
use XF\Template\Templater;

class LoadMessages extends View
{
    public function renderJson()
    {
        $messages = [];
        /** @var Templater $templater */
        $templater = $this->renderer->getTemplater();
        $func = Listener::templaterFunc();

        foreach ($this->params['messages'] AS $message) 
        {
            $messages[] = [
                'message_id' => $message->message_id,
                'user_id' => $message->user_id,
                'is_to' => $message->isTo(),
                'is_pm' => $message->isPm(),
                'avatar' => $templater->$func('avatar', [$message->User, 'xxs']),
                'username' => $templater->$func('username_link', [$message->User, true, [
                    'notooltip' => true,
                    'data-xf-click' => 'chat-insert',
                    'data-insert' => "/to @{$message->User->username}, ",
                    'data-replace' => "/pm @{$message->User->username}, ",
                    'data-regex' => '^(\/pm|\/to)\s@.[^\s]*,',
                    'data-is-replacer' => 'true'
                ]]),
                'message' => $templater->$func('bb_code', [\XF::app()->stringFormatter()->censorText($message->message), 'chat:message', $message]),
                'controls' => ($message->canEdit() || $message->canDelete() || $message->canReport()),
                'can_edit' => $message->canEdit(),
                'can_delete' => $message->canDelete(),
                'can_report' => $message->canReport(),
                'message_date' => $templater->$func('date_dynamic', [$message->message_date])
            ];
        }

        return [
            'messages' => $messages,
            'last_update' => $this->params['last_update']
        ];
    }
}