<?php

namespace BS\RealTimeChat\Report;

use XF\Entity\Report;
use XF\Mvc\Entity\Entity;
use XF\Report\AbstractHandler;

class ChatMessage extends AbstractHandler
{
	protected function canActionContent(Report $report)
	{
		return \XF::visitor()->hasPermission('general', 'warn');
	}

	public function setupReportEntityContent(Report $report, Entity $content)
	{
		$report->content_user_id = $content->user_id;
		$report->content_info = [
			'message' => $content->message,
			'user_id' => $content->user_id,
			'username' => $content->User->username
		];
	}

	public function getContentTitle(Report $report)
	{
		return \XF::phrase('chat_message');
	}

	public function getContentMessage(Report $report)
	{
		return $report->content_info['message'];
	}

	public function getEntityWith()
	{
		return ['User'];
	}
}