<?php

namespace BS\RealTimeChat\XF\Entity;

class User extends XFCP_User
{
    public function isBannedInChat()
    {
        return !empty($this->ChatBan);
    }

	public function canViewChat()
	{
		return $this->hasChatPermission('canView');
	}

    public function canViewChatHistory()
    {
        return ($this->hasChatPermission('canView') && !$this->isBannedInChat());
    }

    public function canChatBan($user)
    {
        if (!$user instanceof User)
        {
            return false;
        }
        
        return ($this->canViewChat() 
            && $user->user_id != \XF::visitor()->user_id 
            && !$user->is_admin 
            && !$user->is_super_admin 
            && !$user->is_moderator 
            && $this->hasChatPermission('canBan')
        );
    }

    public function canChatViewBanList()
    {
        return $this->hasChatPermission('canViewBanList');
    }

	public function canChatWrite()
	{
		return ($this->user_id && $this->canViewChat() && !$this->isBannedInChat() && $this->hasChatPermission('canWrite'));
	}

    public function canChatClear()
    {
        return ($this->canViewChat() && !$this->isBannedInChat() && $this->hasChatPermission('canClear'));
    }

    public function hasChatPermission($permission)
    {
        return $this->hasPermission('bsChat', $permission);
    }
}

if (false)
{
    class XFCP_User extends \XF\Entity\User {}
}